#ifndef USART_H
#define	USART_H
//------------------------------------------------------------------------------
void USART_init(unsigned long baudRate)
{ 
  TXSTA = 0x24;   //Set TXEN and BRGH(High speed mode),CLear SYNC for Asynchronous mode
  RCSTA = 0x90;   //Set SPEN and CREN(Continuous Receive)
  SPBRG = (int)((_XTAL_FREQ/baudRate)/16) - 1; //Formula according to Datasheet (For Highspeed mode)
  TRISC7 = 1;     //Rx = input
  TRISC6 = 0;     //Tx = output
}
//------------------------------------------------------------------------------
void USART_write(char data)
{
  while(!TRMT);  //Poll if TSR is Full  TRMT   TXIF
  TXREG = data;
}
//------------------------------------------------------------------------------
void USART_string(char text[])
{
  while(*text)
  {
    USART_write(*text++);
  }
}
//------------------------------------------------------------------------------
char USART_read()
{
  while(!RCIF);
  return RCREG;
}
//------------------------------------------------------------------------------
char* USART_readString(const char delim,const int noChars)
{
   char inChar = 0;
   char inStr[15] = "";
   int  count = 0;  

   while( (inChar != delim) && (count < noChars))
   {
    inChar = USART_read();
    inStr[count++] = inChar;
   } 
   
   return inStr;
}
//------------------------------------------------------------------------------
#endif